<!-- /********************************************************************************
* Copyright (c) 2020 Contributors to the Eclipse Foundation
*
* See the NOTICE file(s) distributed with this work for additional
* information regarding copyright ownership.
*
* This program and the accompanying materials are made available under the
* terms of the Eclipse Public License v. 2.0 which is available at
* http://www.eclipse.org/legal/epl-2.0.
*
* SPDX-License-Identifier: EPL-2.0
********************************************************************************/ -->
<app-card-layout>
  <div header>
    <div class="d-flex flex-row-reverse header">
      <div class="col-xs-4 center correctFormatting" view="'list'">
        <button *visibleByRight="RolesEnum.CREATOR" class="btn btn-primary" (click)="sandbox.createGridFailure()">
          {{ 'GridFailures.New' | translate }}
        </button>
      </div>
      <div class="col-xs-4 center" view="'list'">
        <div class="btn-group">
          <button class="btn btn-primary non-outline" (click)="view = 'list'" [class.active]="view === 'list'">
            {{ 'GridFailures.List' | translate }}
          </button>
          <button class="btn btn-primary non-outline" (click)="view = 'map'; clearGridFailureCondensation(); setMapFilter()" [class.active]="view === 'map'">
            {{ 'GridFailures.Map' | translate }}
          </button>
        </div>
      </div>
      <span>{{ 'GridFailures.Title' | translate }}</span>
    </div>
  </div>
  <div class="grid-failures-grid-wrapper" body>
    <div class="grid-failure-information-condensation" *ngIf="view === 'list' && showCondensationTable">
      <div class="table-menu">
        <div class="table-menu-row table-menu-row-flow-right">
          <label id="choosed-grid-failure-information-label">
            {{ 'GridFailures.ChoosedGridFailureInformations' | translate }}
          </label>
          <div class="diverse-condensation-btns">
            <button class="btn btn-primary" (click)="clearGridFailureCondensation(); cancelCondesation()">
              {{ 'CancelBtn' | translate }}
            </button>
            <div class="diverse-condensation-btns" *visibleByRight="[RolesEnum.CREATOR, RolesEnum.QUALIFIER, RolesEnum.PUBLISHER]">
              <button class="btn btn-primary" *ngIf="!enableSelectionMode && showEditCondensationBtn" (click)="changeToSelectionMode()">
                {{ 'GridFailures.EditCondensation' | translate }}
              </button>
              <button class="btn btn-primary" *ngIf="enableSelectionMode" (click)="condenseChoosedGridFailureInformations()">
                {{ 'GridFailures.CondenseChoosedGridFailureInformations' | translate }}
              </button>
            </div>
          </div>
        </div>
      </div>
      <ag-grid-angular
        autoResizeColumns
        class="ag-theme-balham"
        [gridOptions]="gridOptionsCondensation"
        [columnDefs]="condensationColumnDefinition"
        [rowSelection]="'single'"
        [components]="frameworkComponents"
        [rowData]="sandbox.condensationList"
        [overlayNoRowsTemplate]="noRowsTemplate"
        [pagination]="true"
        [paginationPageSize]="Globals.CONDENSATION_TABLE_PAGINATION_PAGE_SIZE"
        [paginationPageSizeSelector]="[Globals.CONDENSATION_TABLE_PAGINATION_PAGE_SIZE, 20, 50, 100]"
      >
      </ag-grid-angular>
    </div>

    <div class="grid-failure-information-overview" *ngIf="view === 'list'; else map">
      <ng-container *visibleByRight="[RolesEnum.CREATOR, RolesEnum.QUALIFIER, RolesEnum.PUBLISHER]">
        <div class="table-menu" *ngIf="!showCondensationTable">
          <div class="table-menu-row table-menu-row-flow-right">
            <label>{{ 'GridFailures.GridFailureListTitle' | translate }}</label>
            <div class="">
              <div class="form-check form-switch custom-control" *visibleByRight="[RolesEnum.PUBLISHER]">
                <input
                  class="form-check-input custom-control-input"
                  type="checkbox"
                  role="switch"
                  id="filterSwitch"
                  [checked]="sandbox.publisherFilterIsActive"
                  [disabled]="sandbox.qualifierFilterIsActive"
                  (change)="changeFilter($event.target.checked, Globals.STATUS_PUBLICATION_FIELD)"
                >
                <label class="form-check-label custom-control-label" for="flexSwitchCheckDefault">{{ 'GridFailures.PublisherFilterLabel' | translate }}</label>
              </div>
              <div class="form-check form-switch custom-control" *visibleByRight="[RolesEnum.QUALIFIER]">
                <input
                  type="checkbox"
                  class="form-check-input custom-control-input"
                  id="qualifierFilterSwitch"
                  [checked]="sandbox.qualifierFilterIsActive"
                  [disabled]="sandbox.publisherFilterIsActive"
                  (change)="changeFilter($event.target.checked, Globals.STATUS_INTERN_FIELD)"
                />
                <label class="form-check-label custom-control-label" for="qualifierFilterSwitch">{{ 'GridFailures.QualifierFilterLabel' | translate }}</label>
              </div>
            </div>
            <button class="btn btn-primary" (click)="changeToSelectionMode()" *visibleByRight="[RolesEnum.CREATOR, RolesEnum.QUALIFIER, RolesEnum.PUBLISHER]">
              {{ 'GridFailures.Condensation' | translate }}
            </button>
          </div>
        </div>
      </ng-container>
      <ag-grid-angular
        autoResizeColumns
        class="ag-theme-balham"
        [gridOptions]="gridOptions"
        [columnDefs]="overviewColumnDefinition"
        [rowSelection]="'single'"
        [components]="frameworkComponents"
        [rowData]="sandbox.overviewGridFailureList"
        [overlayNoRowsTemplate]="noRowsTemplate"
      >
      </ag-grid-angular>
    </div>

    <ng-template #map>
      <openk-grid-failure-information-map
        [mapOptions]="mapOptions"
        [mapData]="sandbox.filteredGridFailureMapList"
        (gridFailureId)="navigateToDetails($event)"
      ></openk-grid-failure-information-map>
    </ng-template>
    <app-spinner [isRunning]="sandbox.gridFailureListLoading$ | async"></app-spinner>
  </div>
</app-card-layout>
